]> git.ipfire.org Git - ipfire-2.x.git/blob - make.sh
Fake-resolv.conf eingefuegt.
[ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0t4" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|devel)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j6"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 mtd
302 lfsmake2 net-tools
303 lfsmake2 patch
304 lfsmake2 psmisc
305 lfsmake2 reiser4progs
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
310 lfsmake2 texinfo
311 lfsmake2 udev
312 lfsmake2 util-linux
313 lfsmake2 vim
314 lfsmake2 grub
315 }
316
317 buildipfire() {
318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
319 export LOGFILE
320 ipfiremake configroot
321 ipfiremake dhcp
322 ipfiremake dhcpcd
323 ipfiremake libusb
324 ipfiremake libpcap
325 ipfiremake linux-atm
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
329 ipfiremake linux SMP=1
330 ipfiremake ipp2p SMP=1
331 ipfiremake fcdsl SMP=1
332 ipfiremake fcdsl2 SMP=1
333 ipfiremake fcdslsl SMP=1
334 ipfiremake fcdslusb SMP=1
335 ipfiremake fcdslslusb SMP=1
336 # ipfiremake promise-sata-300-tx SMP=1
337 ipfiremake zaptel SMP=1
338 ipfiremake fuse SMP=1
339 ipfiremake linux
340 ipfiremake ipp2p
341 ipfiremake fcdsl
342 ipfiremake fcdsl2
343 ipfiremake fcdslsl
344 ipfiremake fcdslusb
345 ipfiremake fcdslslusb
346 # ipfiremake promise-sata-300-tx
347 ipfiremake zaptel
348 ipfiremake fuse
349 ipfiremake pkg-config
350 ipfiremake cpio
351 ipfiremake klibc
352 ipfiremake mkinitcpio
353 ipfiremake udev KLIBC=1
354 ipfiremake expat
355 ipfiremake gdbm
356 ipfiremake gmp
357 ipfiremake pam
358 ipfiremake openssl
359 ipfiremake curl
360 ipfiremake python
361 ipfiremake libnet
362 ipfiremake libjpeg
363 ipfiremake libpng
364 ipfiremake libtiff
365 ipfiremake libart
366 ipfiremake freetype
367 ipfiremake gd
368 ipfiremake popt
369 ipfiremake pcre
370 ipfiremake slang
371 ipfiremake newt
372 ipfiremake libcap
373 ipfiremake pciutils
374 ipfiremake usbutils
375 ipfiremake libxml2
376 ipfiremake libxslt
377 ipfiremake BerkeleyDB
378 ipfiremake mysql
379 ipfiremake cyrus-sasl
380 ipfiremake openldap
381 ipfiremake apache2
382 ipfiremake php
383 ipfiremake apache2 PASS=C
384 ipfiremake arping
385 ipfiremake beep
386 ipfiremake bind
387 ipfiremake capi4k-utils
388 ipfiremake cdrtools
389 ipfiremake dnsmasq
390 ipfiremake dosfstools
391 ipfiremake reiserfsprogs
392 ipfiremake squashfstools
393 ipfiremake sysfsutils
394 ipfiremake ntfs-3g
395 ipfiremake ethtool
396 ipfiremake ez-ipupdate
397 ipfiremake fcron
398 ipfiremake GD
399 ipfiremake GD-Graph
400 ipfiremake GD-TextUtil
401 ipfiremake gnupg
402 ipfiremake hdparm
403 ipfiremake ibod
404 ipfiremake initscripts
405 ipfiremake whatmask
406 ipfiremake iptables
407 ipfiremake libupnp
408 ipfiremake ipp2p IPT=1
409 ipfiremake moblock
410 ipfiremake linux-igd
411 ipfiremake ipac-ng
412 ipfiremake ipaddr
413 ipfiremake iptstate
414 ipfiremake iputils
415 ipfiremake l7-protocols
416 ipfiremake isdn4k-utils
417 ipfiremake mISDN
418 ipfiremake hwdata
419 ipfiremake kudzu
420 ipfiremake logrotate
421 ipfiremake logwatch
422 ipfiremake misc-progs
423 ipfiremake mtools
424 ipfiremake nano
425 ipfiremake nasm
426 ipfiremake URI
427 ipfiremake HTML-Tagset
428 ipfiremake HTML-Parser
429 ipfiremake Compress-Zlib
430 ipfiremake Digest
431 ipfiremake Digest-SHA1
432 ipfiremake Digest-HMAC
433 ipfiremake libwww-perl
434 ipfiremake Net-DNS
435 ipfiremake Net-IPv4Addr
436 ipfiremake Net_SSLeay
437 ipfiremake IO-Stringy
438 ipfiremake Unix-Syslog
439 ipfiremake Mail-Tools
440 ipfiremake MIME-Tools
441 ipfiremake Net-Server
442 ipfiremake Convert-TNEF
443 ipfiremake Convert-UUlib
444 ipfiremake Archive-Tar
445 ipfiremake Archive-Zip
446 ipfiremake Text-Tabs+Wrap
447 ipfiremake Locale-Country
448 ipfiremake XML-Parser
449 ipfiremake MP3-Info
450 ipfiremake MP3-Tag
451 ipfiremake glib
452 ipfiremake GeoIP
453 ipfiremake fwhits
454 ipfiremake noip_updater
455 ipfiremake ntp
456 ipfiremake openssh
457 ipfiremake openswan
458 ipfiremake pptpclient
459 ipfiremake rrdtool
460 ipfiremake setserial
461 ipfiremake setup
462 ipfiremake snort
463 #ipfiremake snortsnarf
464 ipfiremake oinkmaster
465 ipfiremake squid
466 ipfiremake squid-graph
467 ipfiremake squidguard
468 ipfiremake calamaris
469 ipfiremake tcpdump
470 ipfiremake traceroute
471 ipfiremake vlan
472 ipfiremake wireless
473 ipfiremake libsafe
474 ipfiremake 3c5x9setup
475 ipfiremake pakfire
476 ipfiremake java
477 ipfiremake spandsp
478 ipfiremake lzo
479 ipfiremake openvpn
480 ipfiremake pammysql
481 ipfiremake ghostscript
482 ipfiremake cups
483 ipfiremake samba
484 ipfiremake sudo
485 ipfiremake mc
486 ipfiremake wget
487 ipfiremake bridge-utils
488 ipfiremake screen
489 ipfiremake hddtemp
490 ipfiremake smartmontools
491 ipfiremake htop
492 ipfiremake postfix
493 ipfiremake fetchmail
494 ipfiremake cyrusimap
495 ipfiremake webcyradm
496 ipfiremake mailx
497 ipfiremake clamav
498 ipfiremake spamassassin
499 ipfiremake amavisd
500 ipfiremake stund
501 ipfiremake libpri
502 # ipfiremake bristuff
503 ipfiremake asterisk
504 ipfiremake mpg123
505 ipfiremake mpfire
506 ipfiremake backup
507 ipfiremake libmad
508 ipfiremake libogg
509 ipfiremake libvorbis
510 ipfiremake lame
511 ipfiremake sox
512 ipfiremake gnump3d
513 ipfiremake libsigc++
514 ipfiremake applejuice
515 ipfiremake ocaml
516 ipfiremake mldonkey
517 ipfiremake libtorrent
518 ipfiremake rtorrent
519 ipfiremake ipfireseeder
520 ipfiremake rsync
521 ipfiremake tcpwrapper
522 ipfiremake portmap
523 ipfiremake nfs
524 ipfiremake nmap
525 ipfiremake mbmon
526 ipfiremake iftop
527 ipfiremake ncftp
528 ipfiremake cftp
529 ipfiremake etherwake
530 ipfiremake ethereal
531 ipfiremake tftp-hpa
532 ipfiremake bwm-ng
533 ipfiremake tripwire
534 ipfiremake sysstat
535 ipfiremake vsftpd
536 ipfiremake alsa
537 ipfiremake mp3blaster
538 ipfiremake which
539 ipfiremake lsof
540 }
541
542 buildinstaller() {
543 # Run installer scripts one by one
544 LOGFILE="$BASEDIR/log/_build.installer.log"
545 export LOGFILE
546 ipfiremake syslinux
547 ipfiremake as86
548 ipfiremake mbr
549 ipfiremake memtest
550 installmake linux-libc-header
551 installmake binutils
552 ipfiremake uClibc PASS=1
553 ipfiremake gcc INST=1
554 installmake uClibc PASS=2
555 installmake gcc INST=2
556 installmake uClibc PASS=3
557 installmake busybox
558 installmake udev
559 installmake slang
560 installmake newt
561 installmake gettext
562 installmake kbd
563 installmake popt
564 installmake sysvinit
565 installmake misc-progs
566 installmake libaal
567 installmake reiser4progs
568 installmake reiserfsprogs
569 installmake sysfsutils
570 installmake util-linux
571 installmake pciutils
572 installmake zlib
573 installmake mtd
574 installmake wget
575 installmake hwdata
576 installmake kudzu
577 installmake installer
578 installmake initrd
579 }
580
581 buildpackages() {
582 LOGFILE="$BASEDIR/log/_build.packages.log"
583 export LOGFILE
584 echo "... see detailed log in _build.*.log files" >> $LOGFILE
585
586 installmake strip
587
588 # Generating list of packages used
589 echo -n "Generating packages list from logs" | tee -a $LOGFILE
590 rm -f $BASEDIR/doc/packages-list
591 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
592 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
593 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
594 fi
595 done
596 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
597 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
598 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
599 rm -f $BASEDIR/doc/packages-list
600 # packages-list.txt is ready to be displayed for wiki page
601 beautify message DONE
602
603 # Create images for install
604 if [ "$DEVEL" == "1" ]; then
605 ipfiremake cdrom ED=devel
606 fi
607 ipfiremake cdrom ED=full
608
609 # Check if there is a loop device for building in virtual environments
610 if [ -e /dev/loop0 ]; then
611 ipfiremake usb-stick
612 fi
613 ipfiremake pxe
614 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
615
616 ipfirepackages
617
618 # Cleanup
619 stdumount
620 rm -rf $BASEDIR/build/tmp/*
621
622 # Generating total list of files
623 echo -n "Generating files list from logs" | tee -a $LOGFILE
624 rm -f $BASEDIR/log/FILES
625 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
626 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
627 echo "##" >>$BASEDIR/log/FILES
628 echo "## `basename $i`" >>$BASEDIR/log/FILES
629 echo "##" >>$BASEDIR/log/FILES
630 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
631 fi
632 done
633 beautify message DONE
634
635 cd $PWD
636 }
637
638 ipfirepackages() {
639 ipfiredist alsa
640 # ipfiredist amavisd
641 ipfiredist applejuice
642 # ipfiredist asterisk
643 ipfiredist clamav
644 ipfiredist cups
645 ipfiredist cyrus-sasl
646 # ipfiredist fetchmail
647 # ipfiredist gnump3d
648 ipfiredist ipfireseeder
649 ipfiredist java
650 ipfiredist libogg
651 ipfiredist libvorbis
652 # ipfiredist mailx
653 # ipfiredist mldonkey
654 ipfiredist mp3blaster
655 ipfiredist mpfire
656 ipfiredist mpg123
657 # ipfiredist nfs
658 ipfiredist openldap
659 # ipfiredist postfix
660 ipfiredist rtorrent
661 ipfiredist samba
662 # ipfiredist sox
663 # ipfiredist spamassassin
664 ipfiredist tripwire
665 ipfiredist vsftpd
666 # ipfiredist webcyradm
667 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
668 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
669 rm -rf $BASEDIR/build/install/packages/*
670 }
671
672 # See what we're supposed to do
673 case "$1" in
674 build)
675 clear
676 BUILDMACHINE=`uname -m`
677 DEVEL=0
678 if [ "$2" == "--devel" ]; then
679 DEVEL=1
680 fi
681 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
682 #only restore on a clean disk
683 if [ ! -f log/cleanup-toolchain-2-tools ]; then
684 if [ ! -n "$PACKAGE" ]; then
685 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
686 prepareenv
687 buildtoolchain
688 else
689 PACKAGENAME=${PACKAGE%.tar.gz}
690 beautify build_stage "Packaged toolchain compilation"
691 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
692 tar zxf $PACKAGE
693 prepareenv
694 else
695 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
696 fi
697 fi
698 else
699 echo -n "Using installed toolchain" | tee -a $LOGFILE
700 beautify message SKIP
701 prepareenv
702 fi
703
704 beautify build_start
705 beautify build_stage "Building LFS"
706 buildbase
707
708 beautify build_stage "Building IPFire"
709 buildipfire
710
711 # Setzen des IPFire Builds
712 if [ "$FIREBUILD" ]; then
713 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
714 else
715 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
716 fi
717
718 beautify build_stage "Building installer"
719 buildinstaller
720
721 beautify build_stage "Building packages"
722 buildpackages
723 beautify build_end
724 ;;
725 shell)
726 # enter a shell inside LFS chroot
727 # may be used to changed kernel settings
728 prepareenv
729 entershell
730 ;;
731 changelog)
732 echo -n "Loading new Changelog from SVN: "
733 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
734 beautify message DONE
735 ;;
736 clean)
737 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
738 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
739 $LOSETUP -d $i 2>/dev/null
740 done
741 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
742 umount $i
743 done
744 stdumount
745 for i in `seq 0 7`; do
746 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
747 umount /dev/loop${i} 2>/dev/null;
748 losetup -d /dev/loop${i} 2>/dev/null;
749 fi;
750 done
751 rm -rf $BASEDIR/build
752 rm -rf $BASEDIR/cdrom
753 rm -rf $BASEDIR/packages
754 rm -rf $BASEDIR/log
755 if [ -h /tools ]; then
756 rm -f /tools
757 fi
758 beautify message DONE
759 ;;
760 downloadsrc)
761 if [ ! -d $BASEDIR/cache ]; then
762 mkdir $BASEDIR/cache
763 fi
764 mkdir -p $BASEDIR/log
765 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
766 FINISHED=0
767 cd $BASEDIR/lfs
768 for c in `seq $MAX_RETRIES`; do
769 if (( FINISHED==1 )); then
770 break
771 fi
772 FINISHED=1
773 cd $BASEDIR/lfs
774 for i in *; do
775 if [ -f "$i" -a "$i" != "Config" ]; then
776 echo -ne "Loading $i"
777 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
778 if [ $? -ne 0 ]; then
779 beautify message FAIL
780 FINISHED=0
781 else
782 if [ $c -eq 1 ]; then
783 beautify message DONE
784 fi
785 fi
786 fi
787 done
788 done
789 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
790 ERROR=0
791 for i in *; do
792 if [ -f "$i" -a "$i" != "Config" ]; then
793 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
794 if [ $? -ne 0 ]; then
795 echo -ne "MD5 difference in lfs/$i"
796 beautify message FAIL
797 ERROR=1
798 fi
799 fi
800 done
801 if [ $ERROR -eq 0 ]; then
802 echo -ne "${BOLD}all files md5sum match${NORMAL}"
803 beautify message DONE
804 else
805 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
806 beautify message FAIL
807 fi
808 cd - >/dev/null 2>&1
809 ;;
810 toolchain)
811 clear
812 prepareenv
813 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
814 buildtoolchain
815 BUILDMACHINE=`uname -m`
816 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
817 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
818 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
819 build/{bin,etc,usr/bin,usr/local} \
820 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
821 log >> $LOGFILE
822 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
823 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
824 stdumount
825 ;;
826 gettoolchain)
827 BUILDMACHINE=`uname -m`
828 # arbitrary name to be updated in case of new toolchain package upload
829 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
830 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
831 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
832 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
833 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
834 cd $BASEDIR/cache/toolchains
835 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
836 if [ $? -ne 0 ]; then
837 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
838 else
839 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
840 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
841 else
842 exiterror "$PACKAGE.md5 did not match, check downloaded package"
843 fi
844 fi
845 else
846 echo "Toolchain is already downloaded. Exiting..."
847 fi
848 ;;
849 othersrc)
850 prepareenv
851 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
852 chroot $LFS /tools/bin/env -i HOME=/root \
853 TERM=$TERM PS1='\u:\w\$ ' \
854 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
855 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
856 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
857 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
858 if [ $? -eq "0" ]; then
859 beautify message DONE
860 else
861 beautify message FAIL
862 fi
863 stdumount
864 ;;
865 svn)
866 case "$2" in
867 update|up)
868 # clear
869 echo -ne "Loading the latest source files...\n"
870 if [ $3 ]; then
871 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
872 else
873 svn update | tee -a $PWD/log/_build.svn.update.log
874 fi
875 if [ $? -eq "0" ]; then
876 beautify message DONE
877 else
878 beautify message FAIL
879 exit 1
880 fi
881 echo -ne "Writing the svn-info to a file"
882 svn info > $PWD/svn_status
883 if [ $? -eq "0" ]; then
884 beautify message DONE
885 else
886 beautify message FAIL
887 exit 1
888 fi
889 chmod 755 $0
890 exit 0
891 ;;
892 commit|ci)
893 clear
894 if [ -f /usr/bin/mcedit ]; then
895 export EDITOR=/usr/bin/mcedit
896 fi
897 if [ -f /usr/bin/nano ]; then
898 export EDITOR=/usr/bin/nano
899 fi
900 echo -ne "Selecting editor $EDITOR..."
901 beautify message DONE
902 if [ -e /sbin/yast ]; then
903 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
904 $0 changelog
905 fi
906 fi
907 update_langs
908 svn commit
909 $0 svn up
910 if [ -n "$FTP_CACHE_URL" ]; then
911 $0 uploadsrc
912 fi
913 ;;
914 dist)
915 if [ $3 ]; then
916 SVN_REVISION=$3
917 fi
918 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
919 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
920 exit 0
921 fi
922 echo -en "REV $SVN_REVISION: Downloading..."
923 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
924 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
925 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
926 evaluate 1
927
928 echo -en "REV $SVN_REVISION: Compressing files..."
929 if [ -e ipfire-source/trunk/make.sh ]; then
930 chmod 755 ipfire-source/trunk/make.sh
931 fi
932 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
933 evaluate 1
934 echo -en "REV $SVN_REVISION: Cleaning up..."
935 rm ipfire-source/ -r
936 evaluate 1
937 ;;
938 diff|di)
939 update_langs
940 echo -ne "Make a local diff to last svn revision"
941 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
942 evaluate 1
943 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
944 svn status
945 ;;
946 esac
947 ;;
948 uploadsrc)
949 PWD=`pwd`
950 cd $BASEDIR/cache/
951 echo -e "Uploading cache to ftp server:"
952 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
953 for i in *; do
954 if [ "$i" == "toolchains" ]; then continue; fi
955 grep -q $i /tmp/ftplist
956 if [ "$?" -ne "0" ]; then
957 echo -ne "$i"
958 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
959 if [ "$?" -ne "0" ]; then
960 beautify message FAIL
961 fi
962 fi
963 done
964 rm -f /tmp/ftplist
965 cd $PWD
966 exit 0
967 ;;
968 upload)
969 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
970 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
971 if [ -z $FTP_ISO_PORT ]; then
972 FTP_ISO_PORT=21
973 fi
974 cat <<EOF > .ftp-commands
975 mkdir -p $FTP_ISO_PATH$SVN_REVISION
976 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
977 quit
978 EOF
979 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
980 rm -f .ftp-commands
981
982 case "$2" in
983 iso)
984 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
985
986 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
987 for i in "svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5"; do
988 #if [ -e "$i" ]; then
989 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
990 if [ "$?" -eq "0" ]; then
991 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
992 else
993 echo "There was an error while uploading the file $i to the ftp server."
994 exit 1
995 fi
996 #fi
997 done
998 if [ "$3" = "--with-sources-cd" ]; then
999 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
1000 fi
1001 ;;
1002 paks)
1003 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
1004 if [ "$?" -eq "0" ]; then
1005 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
1006 else
1007 echo -e "There was an error while uploading the packages to the ftp server."
1008 exit 1
1009 fi
1010 ;;
1011 esac
1012 ;;
1013 batch)
1014 if [ "$2" = "--background" ]; then
1015 batch_script
1016 exit $?
1017 fi
1018 if [ `screen -ls | grep -q ipfire` ]; then
1019 echo "Build is already running, sorry!"
1020 exit 1
1021 else
1022 if [ "$2" = "--rebuild" ]; then
1023 export IPFIRE_REBUILD=1
1024 echo "REBUILD!"
1025 else
1026 export IPFIRE_REBUILD=0
1027 fi
1028 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1029 screen -dmS ipfire $0 batch --background
1030 evaluate 1
1031 exit 0
1032 fi
1033 ;;
1034 watch)
1035 watch_screen
1036 ;;
1037 pxe)
1038 case "$2" in
1039 start)
1040 start_tftpd
1041 ;;
1042 stop)
1043 stop_tftpd
1044 ;;
1045 reload|restart)
1046 reload_tftpd
1047 ;;
1048 esac
1049 exit 0
1050 ;;
1051 lang)
1052 update_langs
1053 ;;
1054 packages)
1055 case "$2" in
1056 sign)
1057 sign_packages
1058 ;;
1059 esac
1060 ;;
1061 "")
1062 clear
1063 svn info
1064 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1065 do
1066 case $name in
1067 "IPFIRE: Downloadsrc")
1068 $0 downloadsrc
1069 ;;
1070 "IPFIRE: Build (silent)")
1071 $0 build-silent
1072 ;;
1073 "IPFIRE: Watch Build")
1074 $0 watch
1075 ;;
1076 "IPFIRE: Batch")
1077 $0 batch
1078 ;;
1079 "IPFIRE: Clean")
1080 $0 clean
1081 ;;
1082 "SVN: Update")
1083 $0 svn update
1084 ;;
1085 "Help")
1086 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1087 cat doc/make.sh-usage
1088 ;;
1089 "LOG: Tail")
1090 tail -f log/_*
1091 ;;
1092 "Exit")
1093 break
1094 ;;
1095 esac
1096 done
1097 ;;
1098 config)
1099 make_config
1100 ;;
1101 *)
1102 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1103 cat doc/make.sh-usage
1104 ;;
1105 esac